SystemOrganization addCategory: #'UCA-Calendario'!

Object subclass: #Calendario
	instanceVariableNames: 'diasNoLaborables feriadosTrasladables feriadosDiaDelMes feriadosConValidez feriadosDiaParticular'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UCA-Calendario'!

!Calendario methodsFor: 'agregar' stamp: 'RU 11/5/2012 14:00'!
agregarFeriadoDesde: unDia hasta:otroDia
	|unaFechaConRango|

	unaFechaConRango:= FechaYValidez conInicio: unDia yRango: (otroDia subtractDate: unDia ).
	feriadosConValidez add: unaFechaConRango.! !

!Calendario methodsFor: 'agregar' stamp: 'RU 11/5/2012 14:48'!
agregarFeriadoDiaDelMesConNumero: unNumero conDia: unDia
	|unDiaDelMes|

	unDiaDelMes:= DiaDelMes  conNumero: unNumero conDia: unDia.
	feriadosDiaDelMes add: unDiaDelMes.! !

!Calendario methodsFor: 'agregar' stamp: 'RU 11/5/2012 14:48'!
agregarFeriadoMes: unMes Dia: unDia 
	|unaFechaConMesYDia|

	unaFechaConMesYDia:= FechaConMesYDia  conMes: unMes conDia: unDia.
	diasNoLaborables add: unaFechaConMesYDia.! !

!Calendario methodsFor: 'agregar' stamp: 'RU 11/5/2012 14:54'!
agregarFeriadoParticularConAnio: unAnio conMes: unMes conDia: unDia	
	|unaFechaConAnioMesYDia|

	unaFechaConAnioMesYDia:= FechaParticularConAnioMesYDia  conAnio: unAnio conMes: unMes conDia: unDia.
	feriadosDiaParticular add: unaFechaConAnioMesYDia.! !

!Calendario methodsFor: 'agregar' stamp: 'RU 11/4/2012 21:49'!
agregarFeriadoTrasladableMes: unMes Dia: unDia 
	|unaFecha|

	unaFecha:= FechaConMesYDia  conMes: unMes conDia: unDia.
	feriadosTrasladables add: unaFecha.! !

!Calendario methodsFor: 'verificar' stamp: 'RU 11/5/2012 14:44'!
esFeriadoConValidez: unDia
	^ (feriadosConValidez anySatisfy: [:each| each estaDentroDelRango: unDia] ) not! !

!Calendario methodsFor: 'verificar' stamp: 'RU 11/5/2012 14:44'!
esFeriadoDiaDelMes:unDia
	^ (feriadosDiaDelMes anySatisfy: [ :each | each diaEs: (unDia dayOfMonth) numeroEs:  (unDia monthIndex)]) not! !

!Calendario methodsFor: 'verificar' stamp: 'RU 11/5/2012 14:44'!
esFeriadoDiaMes: unDia
	^ (diasNoLaborables anySatisfy: [ :each | each diaEs: (unDia dayOfMonth) mesEs:  (unDia monthIndex)] ) not! !

!Calendario methodsFor: 'verificar' stamp: 'RU 11/5/2012 15:01'!
esFeriadoDiaParticular: unDia
	^ (feriadosDiaParticular anySatisfy: [ :each | each anioEs: (unDia year) mesEs:   (unDia monthIndex)] diaEs: (unDia dayOfMonth)  ) not! !

!Calendario methodsFor: 'as yet unclassified' stamp: 'RU 11/5/2012 14:36'!
esLaborable: unDia
	^ ((self noEsSabadoODomingo: unDia) & (self esFeriadoDiaMes: unDia ) & (self esFeriadoDiaDelMes: unDia) & (self esFeriadoConValidez: unDia)) ! !

!Calendario methodsFor: 'as yet unclassified' stamp: 'RU 11/5/2012 14:50'!
initialize
	diasNoLaborables:=OrderedCollection new.
	feriadosDiaParticular:= OrderedCollection new.
	feriadosTrasladables:= OrderedCollection new.
	feriadosDiaDelMes:= OrderedCollection new.
	feriadosDiaParticular:= OrderedCollection new.
	feriadosConValidez:= OrderedCollection new.! !

!Calendario methodsFor: 'verificar' stamp: 'RU 11/5/2012 14:36'!
noEsSabadoODomingo: unDia
	^ (unDia dayOfWeek > 1) & (unDia dayOfWeek < 7)! !

Object subclass: #DiaDelMes
	instanceVariableNames: 'numero dia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UCA-Calendario'!

!DiaDelMes class methodsFor: 'as yet unclassified' stamp: 'RU 11/4/2012 22:15'!
conNumero: unNumero conDia: unDia.
	^self inicializarConNumero: unNumero conDia: unDia.! !

!DiaDelMes methodsFor: 'as yet unclassified' stamp: 'RU 11/4/2012 22:16'!
inicializarConNumero: unNumero conDia: unDia
	numero:=unNumero.
	dia:=unDia! !

Object subclass: #FechaConMesYDia
	instanceVariableNames: 'dia mes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UCA-Calendario'!

!FechaConMesYDia class methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 20:30'!
conMes: unMes conDia: unDia
	^self new inicializarConMes: unMes conDia: unDia! !

!FechaConMesYDia methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 21:24'!
diaEs:unDia mesEs:unMes
	^(dia=unDia & mes=unMes)! !

!FechaConMesYDia methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 20:30'!
inicializarConMes: unMes conDia: unDia
	mes:=unMes.
	dia:=unDia! !

Object subclass: #FechaParticularConAnioMesYDia
	instanceVariableNames: 'dia mes anio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UCA-Calendario'!

!FechaParticularConAnioMesYDia class methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 21:37'!
conAnio: unAnio conMes: unMes conDia: unDia
	^self new inicializarConAnio: unAnio conMes: unMes conDia: unDia! !

!FechaParticularConAnioMesYDia methodsFor: 'as yet unclassified' stamp: 'RU 11/5/2012 14:56'!
anioEs: unAnio diaEs: unDia mesEs: unMes
	^(anio= unAnio & dia=unDia & mes=unMes)! !

!FechaParticularConAnioMesYDia methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 21:37'!
inicializarConAnio:unAnio conMes: unMes conDia: unDia
	anio:=unAnio.
	mes:=unMes.
	dia:=unDia! !

Object subclass: #FechaYValidez
	instanceVariableNames: 'rango diaInicio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UCA-Calendario'!

!FechaYValidez class methodsFor: 'as yet unclassified' stamp: 'RU 11/5/2012 14:01'!
conInicio: unDia yRango: unRango
	^self new inicializarConInicio: unDia yRango: unRango! !

!FechaYValidez methodsFor: 'as yet unclassified' stamp: 'RU 11/5/2012 14:03'!
estaDentroDelRango: unDia
	^((unDia subtractDate: diaInicio)<=rango)! !

!FechaYValidez methodsFor: 'as yet unclassified' stamp: 'RU 11/4/2012 23:06'!
inicializarConInicio: unDia yRango: unRango
	diaInicio:=unDia.
	rango:= unRango! !

TestCase subclass: #TestCalendario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UCA-Calendario'!

!TestCalendario methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 19:53'!
test01DadoUnDiaDomingoNoEsLaborable
	|dia28oct2012 unCalendario|

	dia28oct2012:=Date year: 2012 month:  10 day: 28. 
	unCalendario:= Calendario new.
	
	self deny: ( unCalendario esLaborable: dia28oct2012)! !

!TestCalendario methodsFor: 'as yet unclassified' stamp: 'RU 11/5/2012 14:45'!
test02DadoUnDiaLunesEsLaborable
	|dia29oct2012 unCalendario|

	dia29oct2012:=Date year: 2012 month:  10 day: 29. 
	unCalendario:= Calendario new.
	
	self assert: (unCalendario esLaborable: dia29oct2012)! !

!TestCalendario methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 20:19'!
test03DadoUnDia25DeDiciembreEsFeriado
	|dia25dic2012 unCalendario|

	dia25dic2012:=Date year: 2012 month:12 day: 25. 
	unCalendario:= Calendario new.
	unCalendario agregarFeriadoMes: 12 Dia: 25.	
	
	self deny: ( unCalendario esLaborable: dia25dic2012)! !

!TestCalendario methodsFor: 'as yet unclassified' stamp: 'RU 11/5/2012 14:51'!
test04DadoUnDiaEnParticularSaberSiEsFeriado
	|dia25sept1981 unCalendario|

	dia25sept1981:=Date year: 2012 month:9 day: 25. 
	unCalendario:= Calendario new.
	unCalendario agregarFeriadoParticularConAnio: 1987 conMes: 12 conDia: 25.	
	
	self deny: ( unCalendario esLaborable: dia25sept1981)! !

!TestCalendario methodsFor: 'as yet unclassified' stamp: 'RU 11/4/2012 22:00'!
test05DadoUnDiaEnParticularSaberSiEsFeriado
	|dia17ago2012 dia13ago2012 unCalendario|

	dia17ago2012:=Date year: 2012 month: 8 day: 17. 
	dia17ago2012:=Date year: 2012 month: 8 day: 13.
	unCalendario:= Calendario new.
	
	unCalendario agregarFeriadoTrasladableMes: 8 Dia: 17.	
	
	self assert: true! !

!TestCalendario methodsFor: 'as yet unclassified' stamp: 'RU 11/4/2012 22:12'!
test06DadoUnDiaDelMesSaberSiEsFeriado
	|unCalendario dia5nov2012 dia12nov2012 |

	dia5nov2012:=Date year: 2012 month: 11 day: 5. 
	dia12nov2012:=Date year: 2012 month: 11 day: 12.
	unCalendario:= Calendario new.
	
	unCalendario agregarFeriadoDiaDelMesConNumero: 1conDia: 2.
	
	self assert: ( unCalendario esLaborable: dia5nov2012).
	self deny: ( unCalendario esLaborable: dia12nov2012)! !

!TestCalendario methodsFor: 'as yet unclassified' stamp: 'RU 11/5/2012 15:03'!
test06DadosDosDiasSaberSiUnDiaIntermedioEsFeriado
	|unCalendario dia5nov2012 dia7nov2012 dia12nov2012 dia13nov2012 |

	dia5nov2012:=Date year: 2012 month: 11 day: 5. 
	dia7nov2012:=Date year: 2012 month: 11 day: 7. 	
	dia12nov2012:=Date year: 2012 month: 11 day: 12.
	dia13nov2012:=Date year: 2012 month: 11 day: 13.
	unCalendario:= Calendario new.
	
	unCalendario agregarFeriadoDesde: dia5nov2012 hasta: dia12nov2012.
	
	self deny: ( unCalendario esLaborable: dia7nov2012).
	self deny: ( unCalendario esLaborable: dia5nov2012).
	self deny: ( unCalendario esLaborable: dia12nov2012).
	self assert: ( unCalendario esLaborable: dia13nov2012).
! !
